Service
Date: 2016-05-24

com.google.common.util.concurrent

## Interface Service

- All Known Implementing Classes:
    AbstractExecutionThreadService, AbstractIdleService, AbstractScheduledService, AbstractService

      @Beta
      public interface Service

  An object with an operational state, plus asynchronous `startAsync()` and `stopAsync()` lifecycle methods to transition between states. Example services include webservers, RPC servers and timers.

  The normal lifecycle of a service is:

  - NEW ->
  - STARTING ->
  - RUNNING ->
  - STOPPING ->
  - TERMINATED

  There are deviations from this if there are failures or if `stopAsync()` is called before the `Service` reaches the RUNNING state. The set of legal transitions form a DAG, therefore every method of the listener will be called at most once. N.B. The `Service.State.FAILED` and `Service.State.TERMINATED` states are terminal states, once a service enters either of these states it cannot ever leave them.

  Implementors of this interface are strongly encouraged to extend one of the abstract classes in this package which implement this interface and make the threading and state management easier.

  Since:
    9.0 (in 1.0 as `com.google.common.base.Service`)

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `Service.Listener` A listener for the various state changes that a `Service` goes through in its lifecycle.
    `static class` | `Service.State` The lifecycle states of a service.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addListener(Service.Listener listener, java.util.concurrent.Executor executor)` Registers a `Service.Listener` to be executed on the given executor.
    `void` | `awaitRunning()` Waits for the `Service` to reach the running state.
    `void` | `awaitRunning(long timeout, java.util.concurrent.TimeUnit unit)` Waits for the `Service` to reach the running state for no more than the given time.
    `void` | `awaitTerminated()` Waits for the `Service` to reach the terminated state.
    `void` | `awaitTerminated(long timeout, java.util.concurrent.TimeUnit unit)` Waits for the `Service` to reach a terminal state (either `terminated` or `failed`) for no more than the given time.
    `java.lang.Throwable` | `failureCause()` Returns the `Throwable` that caused this service to fail.
    `boolean` | `isRunning()` Returns `true` if this service is running.
    `Service` | `startAsync()` If the service state is `Service.State.NEW`, this initiates service startup and returns immediately.
    `Service.State` | `state()` Returns the lifecycle state of the service.
    `Service` | `stopAsync()` If the service is starting or running, this initiates service shutdown and returns immediately.

- - ### Method Detail

    - #### startAsync

          Service startAsync()

      If the service state is `Service.State.NEW`, this initiates service startup and returns immediately. A stopped service may not be restarted.
      Returns:
        this
      Throws:
        `java.lang.IllegalStateException` - if the service is not `Service.State.NEW`
      Since:
        15.0

    - #### isRunning

          boolean isRunning()

      Returns `true` if this service is running.

    - #### state

          Service.State state()

      Returns the lifecycle state of the service.

    - #### stopAsync

          Service stopAsync()

      If the service is starting or running, this initiates service shutdown and returns immediately. If the service is new, it is terminated without having been started nor stopped. If the service has already been stopped, this method returns immediately without taking action.
      Returns:
        this
      Since:
        15.0

    - #### awaitRunning

          void awaitRunning()

      Waits for the `Service` to reach the running state.
      Throws:
        `java.lang.IllegalStateException` - if the service reaches a state from which it is not possible to enter the `Service.State.RUNNING` state. e.g. if the `state` is `State#TERMINATED` when this method is called then this will throw an IllegalStateException.
      Since:
        15.0

    - #### awaitRunning

          void awaitRunning(long timeout,
                          java.util.concurrent.TimeUnit unit)
                            throws java.util.concurrent.TimeoutException

      Waits for the `Service` to reach the running state for no more than the given time.
      Parameters:
        `timeout` - the maximum time to wait
        `unit` - the time unit of the timeout argument
      Throws:
        `java.util.concurrent.TimeoutException` - if the service has not reached the given state within the deadline
        `java.lang.IllegalStateException` - if the service reaches a state from which it is not possible to enter the `RUNNING` state. e.g. if the `state` is `State#TERMINATED` when this method is called then this will throw an IllegalStateException.
      Since:
        15.0

    - #### awaitTerminated

          void awaitTerminated()

      Waits for the `Service` to reach the terminated state.
      Throws:
        `java.lang.IllegalStateException` - if the service fails.
      Since:
        15.0

    - #### awaitTerminated

          void awaitTerminated(long timeout,
                             java.util.concurrent.TimeUnit unit)
                               throws java.util.concurrent.TimeoutException

      Waits for the `Service` to reach a terminal state (either `terminated` or `failed`) for no more than the given time.
      Parameters:
        `timeout` - the maximum time to wait
        `unit` - the time unit of the timeout argument
      Throws:
        `java.util.concurrent.TimeoutException` - if the service has not reached the given state within the deadline
        `java.lang.IllegalStateException` - if the service fails.
      Since:
        15.0

    - #### failureCause

          java.lang.Throwable failureCause()

      Returns the `Throwable` that caused this service to fail.
      Throws:
        `java.lang.IllegalStateException` - if this service's state isn't FAILED.
      Since:
        14.0

    - #### addListener

          void addListener(Service.Listener listener,
                         java.util.concurrent.Executor executor)

      Registers a `Service.Listener` to be executed on the given executor. The listener will have the corresponding transition method called whenever the service changes state. The listener will not have previous state changes replayed, so it is suggested that listeners are added before the service starts.

      `addListener` guarantees execution ordering across calls to a given listener but not across calls to multiple listeners. Specifically, a given listener will have its callbacks invoked in the same order as the underlying service enters those states. Additionally, at most one of the listener's callbacks will execute at once. However, multiple listeners' callbacks may execute concurrently, and listeners may execute in an order different from the one in which they were registered.

      RuntimeExceptions thrown by a listener will be caught and logged. Any exception thrown during `Executor.execute` (e.g., a `RejectedExecutionException`) will be caught and logged.

      Parameters:
        `listener` - the listener to run when the service changes state is complete
        `executor` - the executor in which the listeners callback methods will be run. For fast, lightweight listeners that would be safe to execute in any thread, consider `MoreExecutors.directExecutor()`.
      Since:
        13.0